/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package socialnetwork.entities;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;

/**
 * Represents a blog that belongs to a group.
 * @author gsnewmark
 */
@Entity
public class Blog implements ITextMedia, Serializable {
    
    private String mediaName;
    private IUser creator;
    private SubjectGroup parentGroup;
    private List<Topic> topics;
    private Long id;
    
    public Blog() {
        topics = new ArrayList<Topic>();
    }
    
    @Override
    @ManyToOne(targetEntity=NetworkUser.class)
    public IUser getCreator() {
        return creator;
    }

    public void setCreator(IUser _creator) {
        this.creator = _creator;
    }

    @Override
    @Id @GeneratedValue
    public Long getId() {
        return id;
    }

    public void setId(Long _id) {
        this.id = _id;
    }

    @Override
    @Column(nullable=false)
    public String getMediaName() {
        return mediaName;
    }

    public void setMediaName(String _mediaName) {
        this.mediaName = _mediaName;
    }

    @Override
    @OneToOne(mappedBy="blog")
    public SubjectGroup getParentGroup() {
        return parentGroup;
    }

    @Override
    public void setParentGroup(SubjectGroup _parentGroup) {
        this.parentGroup = _parentGroup;
    }

    @Override
    @OneToMany(mappedBy="topicHolder")
    public List<Topic> getTopics() {
        return topics;
    }

    public void setTopics(List<Topic> _topics) {
        this.topics = _topics;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Blog other = (Blog) obj;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 3;
        hash = 47 * hash + (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "Blog{" + "mediaName=" + mediaName + ", id=" + id + '}';
    }
    
}
