/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package socialnetwork.entities;

import java.util.List;

/**
 * Describes basic text media in our network.
 * @author gsnewmark
 */
public interface ITextMedia {
    
    /**
     * @return name of this media.
     */
    public String getMediaName();
    
    /**
     * @return id of this media.
     */
    public Long getId();
    
    /**
     * @return group in which this media was created.
     */
    public SubjectGroup getParentGroup();

    /**
     * Sets parent group for this media.
     * @param _parentGroup specified group to set.
     */
    public void setParentGroup(SubjectGroup _parentGroup);
    
    /**
     * @return creator of this media.
     */
    public IUser getCreator();
    
    /**
     * @return list of all topics in this media.
     */
    public List<Topic> getTopics();
    
}
