package socialnetwork.entities;

import java.util.Set;

/**
 * Describes user in our network.
 * @author gsnewmark
 */
public interface IUser {
    
    /**
     * @return name of a user
     */
    public String getName();
    
    /**
     * @return description of user (e.g. faculty, year, speciality of student)
     */
    public String getDescription();
    
    /**
     * @return user's identification number
     */
    public Long getId();
    
    /**
     * @return user's login to network
     */
    public String getLogin();
    
    /**
     * @return user's password to network
     */
    public String getPassword();
    
    /**
     * @return list of user subject groups
     */
    public Set<SubjectGroup> getSubjectGroups();
    
}
