/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package socialnetwork.entities;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

/**
 * Represents post in a blog.
 * @author gsnewmark
 */
@Entity
public class Post implements Serializable {
    
    private Long id;
    private IUser creator;
    private String postContents;
    private Topic postHolder;
    
    public Post() {
        
    }

    @ManyToOne(targetEntity=NetworkUser.class)
    public IUser getCreator() {
        return creator;
    }

    public void setCreator(IUser _creator) {
        this.creator = _creator;
    }

    @Id @GeneratedValue
    public Long getId() {
        return id;
    }

    public void setId(Long _id) {
        this.id = _id;
    }

    @Column(nullable=false)
    public String getPostContents() {
        return postContents;
    }

    public void setPostContents(String _postContents) {
        this.postContents = _postContents;
    }

    @ManyToOne
    public Topic getPostHolder() {
        return postHolder;
    }

    public void setPostHolder(Topic _postHolder) {
        this.postHolder = _postHolder;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Post other = (Post) obj;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 47 * hash + (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "Post{" + "id=" + id + ", postContents=" + postContents + '}';
    }

}
