/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package socialnetwork.entities;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

/**
 * Represents topic in a blog.
 * @author gsnewmark
 */
@Entity
public class Topic implements Serializable {
    
    private String topicName;
    private Long id;
    private IUser creator;
    private Blog topicHolder;
    private List<Post> posts;
    
    public Topic() {
        posts = new ArrayList<Post>();
    }

    @ManyToOne(targetEntity=NetworkUser.class)
    public IUser getCreator() {
        return creator;
    }

    public void setCreator(IUser _creator) {
        this.creator = _creator;
    }

    @Id @GeneratedValue
    public Long getId() {
        return id;
    }

    public void setId(Long _id) {
        this.id = _id;
    }

    @OneToMany(mappedBy="postHolder")
    public List<Post> getPosts() {
        return posts;
    }

    public void setPosts(List<Post> _posts) {
        this.posts = _posts;
    }

    @ManyToOne
    public Blog getTopicHolder() {
        return topicHolder;
    }

    public void setTopicHolder(Blog _topicHolder) {
        this.topicHolder = _topicHolder;
    }

    @Column(nullable=false)
    public String getTopicName() {
        return topicName;
    }

    public void setTopicName(String _topicName) {
        this.topicName = _topicName;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Topic other = (Topic) obj;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 89 * hash + (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "Topic{" + "topicName=" + topicName + ", id=" + id + '}';
    }
    
}
