/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package socialnetwork.managedbeans;

import java.util.List;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.faces.context.FacesContext;
import socialnetwork.ejb.SocNetworkDAO;
import socialnetwork.entities.IUser;
import socialnetwork.entities.SubjectGroup;

/**
 * Shows list of student's subject groups.
 * @author gsnewmark
 */
public class GroupListManagedBean {
    @EJB
    private SocNetworkDAO socNetworkDAO;
    private IUser _student;
    private List<SubjectGroup> _groups;
    

    /** Creates a new instance of GroupListManagedBean */
    public GroupListManagedBean() {
        this._student = ((LoginBackingBean) FacesContext.getCurrentInstance().
                getExternalContext().getSessionMap().get("loginBackingBean")).
                getStudent();
         
    }
    
    @PostConstruct
    void init(){
        this._groups = socNetworkDAO.getGroupsFromDB();
    }
    
    public IUser getStudent() {
        return _student;
    }

    public void setStudent(IUser _student) {
        this._student = _student;
    }

    public List<SubjectGroup> getGroups() {
        return _groups;
    }

    public void setGroups(List<SubjectGroup> _groups) {
        this._groups = _groups;
    }

    /**
     * Checks if user belongs to any group.
     * @return true if belong to at least one group
     */
    public boolean showGroups() {
        return this._groups.isEmpty();
    }
    
    public boolean goToGroupPage(long id) {
        FacesContext.getCurrentInstance().getExternalContext().getSessionMap().put("gid", id);
        return true;
    }
    
}
