/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package socialnetwork.servlets;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import socialnetwork.ejb.SocNetworkDAO;

/**
 * Governs admin login.
 * @author gsnewmark
 */
public class LoginLogic extends HttpServlet {
    private static String LOGGED_PAGE;
    private static String UNLOGGED_PAGE;

    @Override
    public void init() throws ServletException {
        super.init();
        LOGGED_PAGE = getServletConfig().getInitParameter("LOGGED_PAGE");
        UNLOGGED_PAGE = getServletConfig().getInitParameter("UNLOGGED_PAGE");
    }
    
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            boolean correctLogin = false;
                correctLogin = ((SocNetworkDAO)getServletContext().
                        getAttribute("DAO")).checkAdminLogin(
                        request.getParameter("login"),
                        request.getParameter("password"));
            HttpSession session = request.getSession();
            if (session.getAttribute("loggedIn") == null || 
                    !(Boolean)session.getAttribute("loggedIn")) {
                session.setAttribute("loggedIn", correctLogin);
            }
            String pageToLoad = UNLOGGED_PAGE;
            if ((Boolean)session.getAttribute("loggedIn")) {
               pageToLoad = LOGGED_PAGE;
            } 
            RequestDispatcher requestDispatcher = getServletContext().
                    getRequestDispatcher(pageToLoad);
            requestDispatcher.forward(request, response);
        }
        finally {            
            out.close();
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
